from .hashpoint import *
from .mentionable import *
from .recursivementionable import *

__all__ = ('hash_point_format', 'tabulate', 'enable_newline', 'disable_newline',)


async def hash_point_format(hash_point: HashPoint, tab: int) -> str:
    assert isinstance(hash_point, HashPoint)
    assert isinstance(tab, int)
    value: Mentionable = await hash_point.resolve()
    assert isinstance(value, Mentionable)
    if isinstance(value, RecursiveMentionable):
        return await value.str(tab)
    else:
        return str(value)


newline = False


def enable_newline():
    global newline
    newline = True


def disable_newline():
    global newline
    newline = False


def tabulate(tab: int) -> str:
    assert isinstance(tab, int)
    if newline:
        return '\n' + '    ' * tab
    else:
        return ' '
