from typing import Generic, TypeVar

from .asserts import *
from .hashpoint import *
from .metaorigin import *
from .origin import *
from .rainbow_factory import *

__all__ = ('LocalMetaOrigin',)

Mentioned = TypeVar('Mentioned')


class LocalMetaOrigin(MetaOrigin[Mentioned], Generic[Mentioned]):
    def __init__(self, origin: Origin[Mentioned]):
        assert isinstance(origin, Origin)
        self._origin = origin

    def origin(self, factory: RainbowFactory[Mentioned], point: bytes) -> Origin[Mentioned]:
        assert isinstance(factory, RainbowFactory)
        assert isinstance(point, bytes)
        assert_eq(len(point), HashPoint.HASH_LENGTH)
        return self._origin
