from typing import Generic, TypeVar

from rainbowadn.flow.core import *

__all__ = ('UnitReducer',)

Element = TypeVar('Element')
Out = TypeVar('Out')


class UnitReducer(
    Reducer[Element, Out],
    Generic[Element, Out]
):
    def __init__(self, element: Element):
        self.element = element

    async def reduce(self, reduce: Reduce[Element, Out]) -> Out:
        assert isinstance(reduce, Reduce)
        return await reduce.reduce(reduce.initial, self.element)
