from typing import Generic, TypeVar

from rainbowadn.nullability import *

__all__ = ('StageVerificationProtocol',)

Base = TypeVar('Base')
Stage = TypeVar('Stage')
Header = TypeVar('Header')


class StageVerificationProtocol(Generic[Base, Stage, Header]):
    async def initial(self, previous: Nullable[Base], header: Header, stage: Stage) -> bool:
        raise NotImplementedError

    async def final(self, stage: Stage, base: Base) -> bool:
        raise NotImplementedError

    async def intermediate(self, previous: Stage, stage: Stage) -> bool:
        raise NotImplementedError
